/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾгָĿ¼µļԼ/öļ */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

typedef struct _FILE_NAME {
	UINT32	DirStartClust;				/* ļĿ¼ʼغ */
//	UINT32	Size;						/* ļ */
	UINT8	Name[8+1+3+1];				/* ļ,8+3ֽ,ָ,,ΪδϼĿ¼· */
	UINT8	Attr;						/* ļ */
} FILE_NAME;
#define		MAX_FILE_COUNT		40
FILE_NAME	xdata	FileNameBuffer[ MAX_FILE_COUNT ];	/* ļṹ */
UINT16		FileCount;
UINT8		idata	buf[64];

/* :оָŵĿ¼µļ */
UINT8	ListFile( UINT8 index )
/* indexָĿ¼ڽṹе */
{
	UINT8			s;
	P_FAT_DIR_INFO	pDir;
	PUINT8			pNameBuf;
	UINT32			CurrentDirStartClust;  /* 浱ǰĿ¼ʼغ,ڼӿļöٺʹٶ */
	CH376WriteVar32( VAR_START_CLUSTER, FileNameBuffer[ index ].DirStartClust );  /* ǰĿ¼ϼĿ¼ʼغΪǰغ,൱ڴϼĿ¼ */
	printf( "List Directory: %s\n", FileNameBuffer[ index ].Name );  /* ʾǰҪоٵĿ¼ */
	s = CH376FileOpen( FileNameBuffer[ index ].Name );  /* Ŀ¼,Ϊ˻ȡĿ¼ʼغٶ */
	if ( s == USB_INT_SUCCESS ) return( ERR_FOUND_NAME );  /* ӦǴĿ¼,ǷؽǴļ */
	else if ( s != ERR_OPEN_DIR ) return( s );
	if ( index ) CurrentDirStartClust = CH376ReadVar32( VAR_START_CLUSTER );  /* ǸĿ¼,ȡĿ¼ʼغ */
	else CurrentDirStartClust = 0;  /* ǸĿ¼ */
	CH376FileClose( FALSE );  /* ڸĿ¼һҪر */
	CH376WriteVar32( VAR_START_CLUSTER, CurrentDirStartClust );  /* ǰĿ¼ʼغ,൱ڴ򿪵ǰĿ¼ */
	CH376SetFileName( "*" );  /* ýҪļļ,֧ͨļĿ¼ */
	xWriteCH376Cmd( CMD0H_FILE_OPEN );  /* öļĿ¼ */
	xEndCH376Cmd( );
	while ( 1 ) {
		s = Wait376Interrupt( );
		if ( s == USB_INT_DISK_READ ) {  /* ݶ */
/* ļöٹ,ִܲжϵĲ,,Ҫȡļ,ôԽöٳļ沢öٽȡ䳤ļ */
			CH376ReadBlock( buf );  /* ȡöٵļFAT_DIR_INFOṹ,سsizeof( FAT_DIR_INFO ) */
			xWriteCH376Cmd( CMD0H_FILE_ENUM_GO );  /* öļĿ¼,ȷһٷжݿCH376뵥Ƭֱͬʱ,ٶ */
			xEndCH376Cmd( );
			pDir = (P_FAT_DIR_INFO)buf;  /* ǰļĿ¼Ϣ */
			if ( pDir -> DIR_Name[0] != '.' ) {  /* ǱϼĿ¼,붪 */
				if ( pDir -> DIR_Name[0] == 0x05 ) pDir -> DIR_Name[0] = 0xE5;  /* ַ滻 */
				if ( pDir -> DIR_Name[8] == 'H' && pDir -> DIR_Name[9] == ' '  /* Ƚļչļ͵ķ */
					|| pDir -> DIR_Name[8] == 'E' && pDir -> DIR_Name[9] == 'X' && pDir -> DIR_Name[10] == 'E' ) {
					printf( "This is a .H or .EXE file\n" );
				}
				if ( FileCount < MAX_FILE_COUNT ) {  /* ļṹ㹻 */
					pNameBuf = & FileNameBuffer[ FileCount ].Name;  /* ļṹеļ */
					for ( s = 0; s < 11; s ++ ) {  /* ļ,Ϊ11ַ */
						if ( pDir -> DIR_Name[ s ] != 0x20 ) {  /* Чַ */
							if ( s == 8 ) {  /* չ */
								*pNameBuf = '.';  /* ָ */
								pNameBuf ++;
							}
							*pNameBuf = pDir -> DIR_Name[ s ];  /* ļһַ */
							pNameBuf ++;
						}
					}
					*pNameBuf = 0;  /* ǰļ·Ľ */
					FileNameBuffer[ FileCount ].DirStartClust = CurrentDirStartClust;  /* ¼ǰĿ¼ʼغ,ڼӿļٶ */
					FileNameBuffer[ FileCount ].Attr = pDir -> DIR_Attr;  /* ¼ļ */
					if ( pDir -> DIR_Attr & ATTR_DIRECTORY ) printf( "Dir %4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );  /* жĿ¼ */
					else printf( "File%4d#: %s\n", FileCount, FileNameBuffer[ FileCount ].Name );  /* жļ */
					FileCount ++;  /* Ŀ¼ */
				}
				else {  /* ļṹ̫С,ṹ */
					printf( "FileName Structure Full\n" );
					s = Wait376Interrupt( );
					CH376EndDirInfo( );  /* ȡFAT_DIR_INFOṹ */
					break;  /* ǿֹö */
				}
			}
		}
		else {
			if ( s == ERR_MISS_FILE ) s = USB_INT_SUCCESS;  /* ûҵƥļ */
			break;
		}
	}
/*	if ( s == USB_INT_SUCCESS ) return( s );*/  /* ɹ */
	return( s );
}

UINT8	ListAll( void )  /* Թȵ㷨öUеļĿ¼ */
{
	UINT8	s;
	UINT16	OldFileCount;
	UINT16	RealReadCount;
	FileNameBuffer[ 0 ].Name[0] = '/';  /* Ŀ¼,·,Ŀ¼Ǿ·֮ⶼ· */
	FileNameBuffer[ 0 ].Name[1] = 0;
	FileNameBuffer[ 0 ].DirStartClust = 0;  /* Ŀ¼ʼغ */
	FileNameBuffer[ 0 ].Attr = ATTR_DIRECTORY;  /* Ŀ¼ҲĿ¼,Ϊһ¼ */
	for ( OldFileCount = 0, FileCount = 1; OldFileCount < FileCount; OldFileCount ++ ) {  /* öٵļṹδз,FileCountڱ仯֮ */
		if ( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) {  /* Ŀ¼ */
			s = ListFile( OldFileCount );  /* öĿ¼,¼浽ṹ,FileCountܻı */
			if ( s != USB_INT_SUCCESS ) return( s );
		}
	}

/* UеļĿ¼ȫö,濪ʼݽṹ¼δļ */
	printf( "Total file&dir = %d, Open every file:\n", FileCount );
	for ( OldFileCount = 0; OldFileCount < FileCount; OldFileCount ++ ) {
		if ( ( FileNameBuffer[ OldFileCount ].Attr & ATTR_DIRECTORY ) == 0 ) {  /* ļ,Ŀ¼ */
			printf( "Open file: %s\n", FileNameBuffer[ OldFileCount ].Name );
			CH376WriteVar32( VAR_START_CLUSTER, FileNameBuffer[ OldFileCount ].DirStartClust );  /* ǰļϼĿ¼ʼغΪǰغ,൱ڴϼĿ¼ */
			s = CH376FileOpen( FileNameBuffer[ OldFileCount ].Name );  /* ļ */
			if ( s == USB_INT_SUCCESS ) {  /* ɹļ */
				s = CH376ByteRead( buf, sizeof(buf), &RealReadCount );  /* ֽΪλӵǰλöȡݿ */
				if ( RealReadCount != sizeof(buf) ) printf( "File size = %d\n", RealReadCount );  /* ļȲsizeof(buf) */
				CH376FileClose( FALSE );  /* дر */
			}
		}
	}
}

main( ) {
	UINT8	i, s;
	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
		for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			s = CH376DiskMount( );  /* ʼ̲ԴǷ */
			if ( s == USB_INT_SUCCESS ) break;  /* ׼ */
			else if ( s == ERR_DISK_DISCON ) break;  /* ⵽Ͽ,¼Ⲣʱ */
			if ( CH376GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
		}
		if ( s == ERR_DISK_DISCON ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if ( CH376GetDiskStatus( ) < DEF_DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		i = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
		if ( i == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}
		mDelaymS( 20 );

		printf( "List all file \n" );
		s = ListAll( );  /* öUеļĿ¼ */
		mStopIfError( s );

UnknownUsbDevice:
		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
