/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾֽڶд,ڽADCģɼӵU̻SDļMY_ADC.TXT,
   ļôӵļĩβ,ļô½ļ */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

main( ) {
	UINT8	s;
	UINT8	month, date, hour;
	UINT16	adc;

	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ10*50mS */
		for ( s = 0; s < 10; s ++ ) {  /* ȴʱ,10*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ʼ̲ԴǷ */
		}
//		s = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
//		if ( s == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
//			buf[ s ] = 0;
//			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
//		}

/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		s = CH376FileOpen( "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
		if ( s == USB_INT_SUCCESS ) {  /* ļڲѾ,ƶļָ뵽βԱ */
			printf( "File size = %ld\n", CH376GetFileSize( ) );  /* ȡǰļ */
			printf( "Locate tail\n" );
			s = CH376ByteLocate( 0xFFFFFFFF );  /* Ƶļβ */
			mStopIfError( s );
		}
		else if ( s == ERR_MISS_FILE ) {  /* ûҵļ,½ļ */
			printf( "Create\n" );
			s = CH376FileCreate( NULL );  /* ½ļ,ļѾɾ½,ṩļ,ղѾṩCH376FileOpen */
			mStopIfError( s );
		}
		else mStopIfError( s );  /* ļʱ */
		printf( "Write begin\n" );
		s = sprintf( buf, "ǰļ= %ld ֽ\xd\xa", CH376GetFileSize( ) );  /* עַȲbuf,Ӵ󻺳߷ֶд */
		s = CH376ByteWrite( buf, s, NULL );  /* ֽΪλļд */
		mStopIfError( s );
		printf( "Write ADC data\n" );
		TR0=1;  /* öʱ0ļֵADC */
		for ( hour = 8; hour != 20; hour ++  ) {  /* ѭʽ12 */
			month = 5;  /* ٶ5 */
			date = TL1 & 0x1F;  /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*			adc = get_adc_data( ); */
			adc = ( (UINT16)TH0 << 8 ) | TL0;  /* Ϊ԰ûADC,öʱ0ļADCʾ */
			s = sprintf( buf, "%02d.%02d.%02d ADC=%u\xd\xa", (UINT16)month, date, (UINT16)hour, adc );  /* ݸʽΪһַ */
			s = CH376ByteWrite( buf, s, NULL );  /* ֽΪλļд */
/* ЩUܻ̿Ҫдݺȴһܼ,,ĳЩUзݶʧ,ÿдݺʱټ */
			mStopIfError( s );
			printf( "Current offset ( file point ) is %ld\n", CH376ReadVar32( VAR_CURRENT_OFFSET ) );  /* ȡǰļָ */
		}
//		CH376ByteWrite( buf, 0, NULL );  /* ֽΪλļд,Ϊ0ֽд,ֻڸļĳ,׶дݺ,ְ취ļ */
		printf( "Write end\n" );
		strcpy( buf, "ADCݵ˽\xd\xa" );
		s = CH376ByteWrite( buf, strlen( buf ), NULL );  /* ֽΪλļд */
		mStopIfError( s );
/* ʵʲƷʵʱʱ,ԸҪļںʱ޸Ϊʵֵ,οEXAM10CH376DirInfoRead/CH376DirInfoSaveʵ */
		printf( "Close\n" );
		s = CH376FileClose( TRUE );  /* رļ,Զļ,ֽΪλдļ,óرļԱԶļ */
		mStopIfError( s );

		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
