/* ΪUSB豸ʽӦó, CH372/CH375/CH376Թ߳CH372DBG.C */
/*
; ƬUSBԹ̼  V1.0
; CH372CH375CH376ĵƬм򵥵ĵԹ
; includeֱӰӦϵͳ,ӵĿ
;
; Website:  http://winchiphead.com
; Email:    tech@winchiphead.com
; @2004.08
;****************************************************************************
*/

/* MCS-51ƬC, KC7.0 */
/* ͵ƬӲԴͬʱ, óӦøҪоֲ޸ */

#include "CH376.H"

#define	xEndCH376Cmd( )  /* CH376,SPIӿڷʽ */

#ifdef __C51__
#pragma NOAREGS
#endif

#ifdef __C51__
#ifndef PUINT8X
typedef unsigned char xdata        *PUINT8X;
#endif
#ifndef PUINT8C
typedef unsigned char code         *PUINT8C;
#endif
#endif

#ifndef MAX_DATA_SIZE
#define MAX_DATA_SIZE		20			/* ݳ,Чֵ156 */
#endif

typedef	struct	_USB_DOWN_PACKET {		/* ´ݰṹ,/д */
	UINT8	mCommand;					/* ,Ķ */
	UINT8	mCommandNot;				/* ķ,У´ݰ */
	union {
		UINT8	mByte[4];				/* ͨò */
		UINT16	mWord[2];				/* ͨò,ֽǰ,Little-Endian */
		UINT32	mDword;					/* ͨò,ֽǰ,Little-Endian */
		void	*mAddress;				/* дʼַ,ֽǰ,Little-Endian */
	} u;
	UINT8	mLength;					/* Ļĳ,дֽ */
	UINT8	mBuffer[ MAX_DATA_SIZE ];	/* ݻ */
}	USB_DOWN_PKT;

typedef	struct	_USB_UP_PACKET {		/* ϴݰṹ,״̬/ */
	UINT8	mStatus;					/* ״̬,Ķ */
	UINT8	mCommandNot;				/* ķ,Уϴݰ */
	UINT8	mReserved[4];
	UINT8	mLength;					/* Ļĳ,ֽ */
	UINT8	mBuffer[ MAX_DATA_SIZE ];	/* ݻ */
}	USB_UP_PKT;

typedef union	_USB_DATA_PACKET {		/* USBϴ´ݻ */
	USB_DOWN_PKT	down;
	USB_UP_PKT		up;
}	USB_DATA_PKT;

/* 붨,λ˵
   λ7Ϊ:  0=ʵض, 1=洢SFRд
   "ʵض":
       λ6-λ0Ϊľ, Ϊ00H-7FH, : 00H-3FHΪͨñ׼, 40H-7FHΪӦϵͳйصض
       Ŀǰ汾ͨñ׼:
           00H: ȡԹ̼İ汾,ȡδɵϴݿ
           10H: ȡǰӦϵͳİ汾˵ַ
   "洢SFRд":
       λ6Ϊݴ䷽:      0=/ϴ, 1=д/´
       λ5-λ4Ϊݶд:  00=ֽΪλ/8λ, 01=Ϊλ/16λ, 10=˫Ϊλ/32λ, 11=λΪλ/1λ
       λ1-λ0Ϊ洢ռ:    00=ȡSFR, 01=ȡڲRAM, 10=ȡⲿRAM, 11=ȡROM
       : 80HΪSFR, 83HΪROM, C1HΪдڲRAM, C2HΪдⲿRAM
   ״̬붨: 00HΪɹ, 080HΪ֧, 0FFHΪδĴ */

#define USB_CMD_GET_FW_INFO		0x00
#define USB_CMD_GET_APP_INFO	0x10

#define USB_CMD_MEM_ACCESS		0x80
#define USB_CMD_MEM_DIR_WR		0x40
#define USB_CMD_MEM_WIDTH		0x0C
#define USB_CMD_MEM_W_BYTE		0x00
#define USB_CMD_MEM_W_WORD		0x04
#define USB_CMD_MEM_W_DWORD		0x08
#define USB_CMD_MEM_W_BIT		0x0C
#define USB_CMD_MEM_SPACE		0x03
#define USB_CMD_MEM_S_SFR		0x00
#define USB_CMD_MEM_S_IRAM		0x01
#define USB_CMD_MEM_S_XRAM		0x02
#define USB_CMD_MEM_S_ROM		0x03

#define ERR_SUCCESS				0x00
#define ERR_PARAMETER			0x10
#define ERR_UNSUPPORT			0x80
#define ERR_UNDEFINED			0xFF

#define THIS_FIRMWARE_VER		0x10
#define THIS_APP_SYS_VER		0x09
#define THIS_APP_SYS_STR		"CH376+MCS51"


#define DELAY_START_VALUE		1	  /* ݵƬʱѡֵ,20MHzΪ0,30MHzΪ2 */

UINT8V	FreeUSBmS;

/* CH376ʼӳ */
void	CH376DeviceInit( void ) {
	UINT8 i;
/* USBģʽ, Ҫ */
	xWriteCH376Cmd( CMD_SET_USB_MODE );
	xWriteCH376Data( 2 );  /* Ϊʹù̼USB豸ʽ */
	for ( i=100; i!=0; i-- ) if ( xReadCH376Data( ) == CMD_RET_SUCCESS ) break;  /* ȴɹ,ͨҪȴ10uS-20uS */
	xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
/*	if ( i == 0 ) { CH372/CH375/CH376оƬڲӴӲ }; */

/* USBж,CH376INT#ſӵƬж,жΪ͵ƽЧ½Ч,
   ʹж,ôҲòѯʽ,ɵƬѯCH376INT#Ϊ͵ƽ */
	IT0 = 0;  /* ⲿźΪ͵ƽ */
	IE0 = 0;  /* жϱ־ */
	EX0 = 1;  /* CH376ж,ٶCH376INT#ӵƬINT0 */
}

/* CH376жϷ,ٶCH376INT#ӵƬINT0,ʹüĴ1 */
void	mCH376Interrupt( void ) interrupt 0 using 1 {
	UINT8			cnt;
	UINT8			dat;
	PUINT8			buf;
	PUINT8C			str;
/*	USB_DATA_PKT	udp;*/
#define	pudp		( (USB_DATA_PKT *)&buf )	/* Լṹռõڴ,ΪUSBӲͬʱ,USBıUSB豸 */
#define	IntStatus		dat		/* Լһ洢Ԫ */
	xWriteCH376Cmd( CMD_GET_STATUS );  /* ȡж״̬ȡж */
	FreeUSBmS = 0;  /* USBмʱ */
	IntStatus = xReadCH376Data( );  /* ȡж״̬ */
	xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
/*	IE0 = 0;  жϱ־,뵥ƬӲй,ӦINT0ж */
	if ( IntStatus == USB_INT_EP2_OUT ) {  /* ˵´ɹ,յ */
		xWriteCH376Cmd( CMD_RD_USB_DATA );  /* ӵǰUSBжϵĶ˵㻺ȡݿ,ͷŻ */
		cnt = xReadCH376Data( );  /* ȶȡݳ */
		if ( cnt == 0 ) {  /* Ϊ0,û,ĳЩӦҲԽ0Ϊһ */
			xWriteCH376Cmd( CMD_SET_ENDP7 );  /* USB˵2IN,Ҳϴ˵ */
			xWriteCH376Data( 0x0E );  /* ͬλ,USB˵2INæ,NAK,ʵϴ */
			xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
			return;
		}
		buf = (PUINT8)&pudp->down;  /* ָ */
		do {
			*buf = xReadCH376Data( );  /*  */
			buf ++;
		} while ( -- cnt );
		xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
		if ( pudp->down.mCommand != (UINT8)( ~ pudp->down.mCommandNot ) ) return;  /* У,´ */
		if ( pudp->down.mCommand & USB_CMD_MEM_ACCESS ) {  /* :洢SFRд */
			if ( ( pudp->down.mCommand & USB_CMD_MEM_WIDTH ) != USB_CMD_MEM_W_BYTE ) {  /* ĿǰMCS51ֻֽ֧Ϊλжд */
				pudp->up.mLength = 0;
				pudp->up.mStatus = ERR_UNSUPPORT;  /* ֧ */
			}
			else {  /* ֽΪλжд */
				for ( cnt = 0; cnt != pudp->down.mLength; cnt ++ ) {  /* д */
					dat = pudp->down.mBuffer[ cnt ];  /* ׼д */
					switch( pudp->down.mCommand & USB_CMD_MEM_SPACE ) {  /* 洢ռ */
						case USB_CMD_MEM_S_SFR:
							switch ( pudp->down.u.mByte[0] ) {  /* SFRַ */
								case 0x80:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) P0 = dat;
									else dat = P0;
									break;
								case 0x87:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) PCON = dat;
									else dat = PCON;
									break;
								case 0x88:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) TCON = dat;
									else dat = TCON;
									break;
								case 0x89:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) TMOD = dat;
									else dat = TMOD;
									break;
								case 0x90:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) P1 = dat;
									else dat = P1;
									break;
								case 0x98:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) SCON = dat;
									else dat = SCON;
									break;
								case 0x99:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) SBUF = dat;
									else dat = SBUF;
									break;
								case 0xA0:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) P2 = dat;
									else dat = P2;
									break;
								case 0xA8:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) IE = dat;
									else dat = IE;
									break;
								case 0xB0:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) P3 = dat;
									else dat = P3;
									break;
								case 0xB8:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) IP = dat;
									else dat = IP;
									break;
								case 0xC8:
									if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) T2CON = dat;
									else dat = T2CON;
									break;
								default:
									dat = 0;
									break;
							}
							break;
						case USB_CMD_MEM_S_IRAM:
							if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) *(PUINT8)pudp->down.u.mByte[0] = dat;
							else dat = *(PUINT8)pudp->down.u.mByte[0];
							break;
						case USB_CMD_MEM_S_XRAM:
							if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) *(PUINT8X)( pudp->down.u.mByte[0] | (UINT16)pudp->down.u.mByte[1] << 8 )= dat;
							else dat = *(PUINT8X)( pudp->down.u.mByte[0] | (UINT16)pudp->down.u.mByte[1] << 8 );
							break;
						case USB_CMD_MEM_S_ROM:
							if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) pudp->up.mStatus = ERR_UNSUPPORT;  /* ֧ */
							else dat = *(PUINT8C)( pudp->down.u.mByte[0] | (UINT16)pudp->down.u.mByte[1] << 8 );
							break;
					}
					if ( ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) == 0 ) pudp->up.mBuffer[ cnt ] = dat;  /* ض */
					pudp->down.u.mByte[0] ++;
					if ( pudp->down.u.mByte[0] == 0 ) pudp->down.u.mByte[1] ++;
				}
				if ( pudp->down.mCommand & USB_CMD_MEM_DIR_WR ) pudp->up.mLength = 0;  /* д */
				pudp->up.mStatus = ERR_SUCCESS;
			}
		}
		else switch ( pudp->down.mCommand ) {  /* :ʵض, */
			case USB_CMD_GET_FW_INFO:  /* ȡԹ̼İ汾,ȡδɵϴݿ */
				pudp->up.mBuffer[0] = THIS_FIRMWARE_VER;
				pudp->up.mLength = 1;
				pudp->up.mStatus = ERR_SUCCESS;
				xWriteCH376Cmd( CMD_SET_ENDP7 );  /* USB˵2IN,Ҳϴ˵ */
				xWriteCH376Data( 0x0E );  /* ͬλ,USB˵2INæ,NAK,ʵϴ */
				xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
				break;
			case USB_CMD_GET_APP_INFO:  /* ȡǰӦϵͳİ汾˵ַ */
				pudp->up.mBuffer[0] = THIS_APP_SYS_VER;
				cnt = 0;
				str = THIS_APP_SYS_STR;
				while ( pudp->up.mBuffer[ cnt ] = *str ) { cnt ++; str ++; }  /* ˵ַ */
				pudp->up.mLength = 1 + sizeof( THIS_APP_SYS_STR );
				pudp->up.mStatus = ERR_SUCCESS;
				break;
/* 			case MY_CMD_CH451: */
			default:  /* ֧ */
				pudp->up.mLength = 0;
				pudp->up.mStatus = ERR_UNSUPPORT;
				break;
		}
		xWriteCH376Cmd( CMD_WR_USB_DATA7 );  /* USB˵2ķͻдݿ */
		cnt = pudp->up.mLength + (UINT8)( & ( (USB_UP_PKT *)0 ) -> mBuffer );
		xWriteCH376Data( cnt );  /* дݳ */
		buf = (PUINT8)&pudp->up;  /* ָ״̬ */
		do {
			xWriteCH376Data( *buf );  /* дݵCH376 */
			buf ++;
		} while ( -- cnt );
		xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
	}
	else if ( IntStatus == USB_INT_EP2_IN ) {  /* ݷͳɹ,״̬ѷ */
		xWriteCH376Cmd( CMD_UNLOCK_USB );  /* ͷŵǰUSB,յϴɹжϺ,USB,Աշ */
		xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
	}
	else if ( IntStatus == USB_INT_EP1_IN ) {  /* жݷͳɹ,δõ */
		xWriteCH376Cmd( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
		xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
	}
/* ù̼USBʽ²Ӧóж״̬ */
	else {
		xWriteCH376Cmd( CMD_UNLOCK_USB );  /* ͷŵǰUSB */
		xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
	}
}

/* رCH376USBͨѶ */
void	CH376OffUSB( void ) {
	EX0 = 0;  /* رUSBж,USBģʽʹòѯʽ */
/* USBģʽ, Ҫ */
	xWriteCH376Cmd( CMD_SET_USB_MODE );
	xWriteCH376Data( 0 );  /* ΪδõUSB豸ʽ */
	xEndCH376Cmd( );  /* CH376,SPIӿڷʽ */
	mDelaymS( 10 );  /* ΪUSBлʱ仺,ǱҪʱ,üΪUSB豸Ѿ */
/* CH376Ȼż,ʹCH376лUSBģʽ,ôᵼ֮˫USBͻ */
}

void	device( ) {
	CH376DeviceInit( );  /* ʼUSB豸ģʽ */
	FreeUSBmS = 0;  /* USBмʱ */
	while( 1 ) {
		if ( IsKeyPress( ) ) {  /* м */
			if ( FreeUSBmS >= 250 ) {  /* USBг250 */
				printf( "Exit USB device mode\n" );
				CH376OffUSB( );  /* رUSB豸 */
				return;
			}
		}
		if ( FreeUSBmS < 250 ) FreeUSBmS ++;  /* USBмʱ,USBͨѶûUSBл */
		mDelaymS( 1 );
/* USB豸ģʽȫжϷд,,ȻҲʹòѯʽUSB豸ͨѶ */
	}
}
