/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾֽڶд,ļö,ļ, ڽUе/C51/CH376HFT.CļеСдĸתɴдĸ, д½ļNEWFILE.TXT,
   ҲԭļCH376HFT.C, ôóʾC51Ŀ¼CH376ͷļ, ½NEWFILE.TXTļдʾϢ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ, ½NEWFILE.TXTļдʾϢ */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#define		EN_DISK_QUERY		1	/* ô̲ѯ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

UINT8	CopyAndConvertFile( PUINT8 SrcFileName, PUINT8 TarFileName ) {  /* ļ,ֽڷʽ,ԽٶԽ */
/* SrcFileName Դļ,֧·ָͶ༶Ŀ¼,ַRAM
   TarFileName Ŀļ,֧·ָͶ༶Ŀ¼,ַRAM */
	UINT8	s;
	UINT16	ThisLen, cnt;
	UINT32	FileSize, ByteCount;
	UINT8	TarName;
	UINT32	TarUpDirClust;
	ByteCount = 0;
	do {
		printf( "OpenSrc\n" );  /* עӡ˷ʱ,ƽٶ */
		s = CH376FileOpenPath( SrcFileName );  /* 򿪶༶Ŀ¼µļ,뻺RAM */
		if ( s != USB_INT_SUCCESS ) return( s );
		if ( ByteCount == 0 ) {  /* ״ */
			FileSize = CH376GetFileSize( );  /* ȡǰļ */
			printf( "SrcFileSz=%ld\n", FileSize );
		}
		else {  /* ٴν */
			s = CH376ByteLocate( ByteCount );  /* ֽΪλƶǰļָ뵽ϴθƽλ */
			if ( s != USB_INT_SUCCESS ) return( s );
		}
		printf( "Read\n" );
		s = CH376ByteRead( buf, sizeof( buf ), &ThisLen );  /* ֽΪλӵǰλöȡݿ,󳤶ͬС,ʵʳThisLen */
		if ( s != USB_INT_SUCCESS ) return( s );
//		s = CH376FileClose( FALSE );  /* رļ,ڶԲعرļ */
//		if ( s != USB_INT_SUCCESS ) return( s );

		for ( cnt=0; cnt < ThisLen; cnt ++ ) {  /* еСдַתΪд */
			s = buf[ cnt ];
			if ( s >= 'a' && s <= 'z' ) buf[ cnt ] = s - ( 'a' - 'A' );
		}

		if ( ByteCount == 0 ) {  /* ״,Ŀļδ */
			printf( "CreateTar\n" );
			TarName = CH376SeparatePath( TarFileName );  /* ·зһļĿ¼,һļĿ¼ƫ */
			if ( TarName ) {  /* Ƕ༶Ŀ¼ */
				s = CH376FileOpenDir( TarFileName, TarName );  /* 򿪶༶Ŀ¼µһĿ¼,½ļϼĿ¼ */
				if ( s != ERR_OPEN_DIR ) {  /* ΪǴϼĿ¼,,ǳɹĿ¼,ô˵ */
					if ( s == USB_INT_SUCCESS ) return( ERR_FOUND_NAME );  /* м·Ŀ¼,ļ */
					else if ( s == ERR_MISS_FILE ) return( ERR_MISS_DIR );  /* м·ĳĿ¼ûҵ,Ŀ¼ƴ */
					else return( s );  /*  */
				}
				TarUpDirClust = CH376ReadVar32( VAR_START_CLUSTER );  /* ϼĿ¼ʼغ */
			}
			else TarUpDirClust = 0;  /* ĬǸĿ¼ʼغ */
/* ڵǰĿ¼½ļ½ߴ򿪲,ȫ·༶Ŀ¼µļ½ߴ򿪲ٶȿ,
   Ŀļ½ߴ򿪲ô˷(ԴļֱӴȫ·༶Ŀ¼µļ,Ϊٶ,Ҳɲմ˷ӿļ),
   ΪʵֵǰĿ¼µļ½ߴ򿪲,ο漸д,
   ,ҪļڵϼĿ¼ʼغ,൱ڴϼĿ¼,ͨCH376FileOpenPathϼĿ¼,
   ,ҪļֱӶļ(ȥϼĿ¼,κ·ָ,һļ),ͨCH376SeparatePathĿļ */
			s = CH376FileCreate( &TarFileName[TarName] );  /* ڸĿ¼ߵǰĿ¼½ļ,ļѾôɾ */
			if ( s != USB_INT_SUCCESS ) return( s );
		}
		else {  /* ٴν,ĿļѴ */
			printf( "OpenTar\n" );
			CH376WriteVar32( VAR_START_CLUSTER, TarUpDirClust );  /* ĿļڵϼĿ¼ʼغΪǰغ,൱ڴϼĿ¼ */
			s = CH376FileOpen( &TarFileName[TarName] );  /* ļ */
			if ( s != USB_INT_SUCCESS ) return( s );
			s = CH376ByteLocate( ByteCount );  /* ֽΪλƶǰļָ뵽ϴθƽλ */
			if ( s != USB_INT_SUCCESS ) return( s );
		}
		printf( "Write\n" );
		s = CH376ByteWrite( buf, ThisLen, NULL );  /* ֽΪλǰλдݿ,ûд̿ռ,򷵻ʵʳThisLen */
		if ( s != USB_INT_SUCCESS ) return( s );
		printf( "CloseTar\n" );
		s = CH376FileClose( TRUE );  /* رļ,ֽڶдԶļ */
		if ( s != USB_INT_SUCCESS ) return( s );
		ByteCount += ThisLen;
		if ( ThisLen < sizeof( buf ) ) {  /* ʵʶֽСֽ,˵ԭļ */
			if ( ByteCount != FileSize ) printf( "Error on SourceFile reading" );
			break;
		}
	} while( ByteCount < FileSize );
	return( USB_INT_SUCCESS );
}

main( ) {
	UINT8			i, s;
	P_FAT_DIR_INFO	pDir;
	UINT8	xdata	SrcName[64];
	UINT8	xdata	TarName[64];
	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
		for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			s = CH376DiskMount( );  /* ʼ̲ԴǷ */
			if ( s == USB_INT_SUCCESS ) break;  /* ׼ */
			else if ( s == ERR_DISK_DISCON ) break;  /* ⵽Ͽ,¼Ⲣʱ */
			if ( CH376GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
		}
		if ( s == ERR_DISK_DISCON ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if ( CH376GetDiskStatus( ) < DEF_DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		i = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
		if ( i == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

/* ȡԭļ */
		strcpy( SrcName, "\\C51\\CH376HFT.C" );  /* Դļ,༶Ŀ¼µļ·븴ƵRAMٴ,Ŀ¼ߵǰĿ¼µļRAMROM */
		strcpy( TarName, "\\NEWFILE.TXT" );  /* Ŀļ */
		printf( "Open\n" );
		s = CH376FileOpenPath( SrcName );  /* ļ,ļC51Ŀ¼ */
		if ( s == ERR_MISS_DIR || s == ERR_MISS_FILE ) {  /* ûҵĿ¼ûҵļ */
/* гļ,öٿԲοEXAM13ȫö */
			if ( s == ERR_MISS_DIR ) strcpy( buf, "\\*" );  /* C51Ŀ¼гĿ¼µļ */
			else strcpy( buf, "\\C51\\CH376*" );  /* CH376HFT.Cļг\C51Ŀ¼µCH376ͷļ */
			printf( "List file %s\n", buf );
			s = CH376FileOpenPath( buf );  /* öٶ༶Ŀ¼µļĿ¼,뻺RAM */
			while ( s == USB_INT_DISK_READ ) {  /* öٵƥļ */
				CH376ReadBlock( buf );  /* ȡöٵļFAT_DIR_INFOṹ,سsizeof( FAT_DIR_INFO ) */
				pDir = (P_FAT_DIR_INFO)buf;  /* ǰļĿ¼Ϣ */
				if ( pDir -> DIR_Name[0] != '.' ) {  /* ǱϼĿ¼,붪 */
					if ( pDir -> DIR_Name[0] == 0x05 ) pDir -> DIR_Name[0] = 0xE5;  /* ַ滻 */
					pDir -> DIR_Attr = 0;  /* ǿļַԱӡ */
					printf( "*** EnumName: %s\n", pDir -> DIR_Name );  /* ӡ,ԭʼ8+3ʽ,δɺСָ */
				}
				xWriteCH376Cmd( CMD0H_FILE_ENUM_GO );  /* öļĿ¼ */
				xEndCH376Cmd( );
				s = Wait376Interrupt( );
			}
			if ( s != ERR_MISS_FILE ) mStopIfError( s );  /*  */
			printf( "Create\n" );
			s = CH376FileCreatePath( TarName );  /* ½༶Ŀ¼µļ,ֶ֧༶Ŀ¼·,뻺RAM */
			mStopIfError( s );
			printf( "Write\n" );
			strcpy( buf, "Ҳ/C51/CH376HFT.Cļ\xd\n" );
			s = CH376ByteWrite( buf, strlen(buf), NULL );  /* ֽΪλǰλдݿ */
			mStopIfError( s );
			printf( "Close\n" );
			s = CH376FileClose( TRUE );  /* رļ,ֽڶдԶļ */
			mStopIfError( s );
		}
		else {  /* ҵļ߳ */
			mStopIfError( s );
			s = CopyAndConvertFile( SrcName, TarName );  /* ļ */
			mStopIfError( s );
		}

/* ɾĳļ */
/*		printf( "Erase\n" );
		s = CH376FileErase( "/OLD" );  ɾļ
		if ( s != USB_INT_SUCCESS ) printf( "Error: %02X\n", (UINT16)s );  ʾ
*/

/* U̻SDʣռ */
/*		printf( "DiskQuery: " );
		s = CH376DiskQuery( (PUINT32)buf );  ѯʣռϢ,
		mStopIfError( s );
//		printf( "free cap = %ld MB\n", *(PUINT32)buf * DEF_SECTOR_SIZE / 1000000 );  δС,1MΪֽڵλ
		printf( "free cap = %ld MB\n", *(PUINT32)buf / ( 1000000 / DEF_SECTOR_SIZE ) );  һеļܻ,˳ */

UnknownUsbDevice:
		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
