/* 2008.10.18
****************************************
**  Copyright  (C)  W.ch  1999-2009   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH376 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH376 ļϵͳӿ */

/* MCS-51ƬCԵUļдʾ */
/* ʾĿ¼,Լ򿪶༶Ŀ¼µļĿ¼ */

/* C51   CH376HFT.C */
/* LX51  CH376HFT.OBJ */
/* OHX51 CH376HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#include "..\HAL.H"
#include "..\HAL_BASE.C"
#include "..\DEBUG.H"
#include "..\DEBUG.C"
#include "..\PARA_HW.C"		/* Ӳ߲ӷʽ */
//#include "..\PARA_SW.C"		/* ģⲢӷʽ */
//#include "..\SPI_HW.C"		/* ӲSPIӷʽ */
//#include "..\SPI_SW.C"		/* ģSPIʽ */
//#include "..\UART_HW.C"		/* Ӳ첽ӷʽ */
#define		EN_DIR_CREATE	1	/* ֧½༶Ŀ¼ */
#include "..\FILE_SYS.H"
#include "..\FILE_SYS.C"

UINT8		idata	buf[64];

main( ) {
	UINT8	s;

	mDelaymS( 100 );  /* ʱ100 */
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	s = mInitCH376Host( );  /* ʼCH376 */
	mStopIfError( s );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk/SD\n" );
		while ( CH376DiskConnect( ) != USB_INT_SUCCESS ) {  /* UǷ,ȴU̲,SD,ɵƬֱӲѯSDĲ״̬ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ10*50mS */
		for ( s = 0; s < 10; s ++ ) {  /* ȴʱ,10*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH376DiskMount( ) == USB_INT_SUCCESS ) break;  /* ʼ̲ԴǷ */
		}
//		s = CH376ReadBlock( buf );  /* Ҫ,ԶȡݿCH376_CMD_DATA.DiskMountInq,س */
//		if ( s == sizeof( INQUIRY_DATA ) ) {  /* U̵ĳ̺ͲƷϢ */
//			buf[ s ] = 0;
//			printf( "UdiskInfo: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
//		}

		printf( "Create Level 1 Directory /YEAR2008 \n" );
		s = CH376DirCreate( "/YEAR2008" );  /* ½ߴĿ¼,Ŀ¼ڸĿ¼ */
		if ( s == ERR_FOUND_NAME ) printf( "Found a file with same name\n" );
		mStopIfError( s );
		CH376FileClose( FALSE );  /* رĿ¼ */

/* ½Ŀ¼ */
		printf( "Create Level 2 Directory /YEAR2008/MONTH05 \n" );
		strcpy( buf, "/YEAR2008/MONTH05" );  /* Ŀ¼,Ŀ¼YEAR2008Ŀ¼,YEAR2008Ŀ¼ȴ,CH376DirCreatePathļRAM */
		s = CH376DirCreatePath( buf );  /* ½ߴĿ¼,Ŀ¼ڶ༶Ŀ¼,·RAM */
		if ( s == ERR_FOUND_NAME ) printf( "Found a file with same name\n" );
		mStopIfError( s );
//		CH376FileClose( FALSE );  /* ʱرĿ¼,ΪҪ½ߴ򿪵Ŀ¼½ļ */

/* Ŀ¼½ߴ򿪳ɹ,Ŀ¼½һʾļ,
   ַ:һCH376FileCreatePath½༶Ŀ¼µļ,CH376FileCreateڵǰĿ¼½ļ(ǰϼĿ¼ûйر) */
		printf( "Create New File /YEAR2008/MONTH05/DEMO2008.TXT \n" );

//		strcpy( buf, "/YEAR2008/MONTH05/DEMO2008.TXT" );  /* ļ,Ŀ¼YEAR2008/MONTH05༶Ŀ¼,Ŀ¼ȴ,CH376FileCreatePathļRAM */
//		s = CH376FileCreatePath( buf );  /* ½༶Ŀ¼µļ,ļѾɾ½,·RAM */

		s = CH376FileCreate( "DEMO2008.TXT" );  /* ڵǰĿ¼½ļ,ļѾɾ½ */

		mStopIfError( s );

		printf( "Write some data to file\n" );
		strcpy( buf, "This is ʾ\xd\xa" );
		s = CH376ByteWrite( buf, strlen(buf), NULL );  /* ֽΪλǰλдݿ */
		mStopIfError( s );

		printf( "Close\n" );
		s = CH376FileClose( TRUE );  /* رļ,Զļ */
		mStopIfError( s );

/* 򿪶༶Ŀ¼µļ */
		printf( "Open File /YEAR2008/MONTH05/DEMO2008.TXT \n" );
		strcpy( buf, "/YEAR2008/MONTH05/DEMO2008.TXT" );  /* CH376FileOpenPathļRAM */
		s = CH376FileOpenPath( buf );  /* ֱӴ򿪶༶Ŀ¼µļ,CH376FileOpenPathӳڲɶ𼶴϶ */
		mStopIfError( s );

		printf( "Close\n" );
		s = CH376FileClose( FALSE );  /* رļ */
		mStopIfError( s );

		printf( "Take out\n" );
		while ( CH376DiskConnect( ) == USB_INT_SUCCESS ) {  /* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}
